# -*- tab-width: 4 -*-
import os,signal,logging

from hotwire.sysdep.proc import Process

_logger = logging.getLogger("hotwire.proc.Unix")

class UnixProcess(Process):
    def kill(self):
        UnixProcessManager._kill_pid(self.pid)

class UnixProcessManager(object):
    def interrupt_pid(self, pid):
        try:
            os.kill(pid, signal.SIGHUP)
            return True
        except OSError, e:
            _logger.debug("Failed to interrupt pid '%d': %s", pid, e)
            return False

    def kill_pid(self, pid):
        UnixProcessManager._kill_pid(pid)

    @staticmethod
    def _kill_pid(pid):
        try:
            os.kill(pid, signal.SIGKILL)
            return True
        except OSError, e:
            _logger.debug("Failed to kill pid '%d': %s", pid, e)
            return False

    def get_extra_subproc_args(self):
        return {'close_fds': True, 'preexec_fn': lambda: os.setsid()}
